//filename: main.cpp

#include <windows.h>
#include <stdlib.h>
#include <wtypes.h>
#include <conio.h>
#include <stdio.h>
#include "main.h"

// ##################################
// See notes at the end of this file
// ##################################

BOOLEAN LoadLibraries()
{
	hLibLL_USB = LoadLibrary ("LL_USB2k.dll");
    if(!hLibLL_USB) return FALSE;
    return TRUE;
}

BOOLEAN InitLibFuncs()
{  
	EX_Connect = (P_DLL_EX_CONNECT)GetProcAddress(hLibLL_USB, "EX_Connect");
	if(!EX_Connect) return FALSE;
	EX_SetDevToIniSetup = (P_EX_SET_DEV_TO_INI_SETUP)GetProcAddress(hLibLL_USB, "EX_SetDevToIniSetup");
	if(!EX_SetDevToIniSetup) return FALSE;
	EX_SetDevToDefaultSetup = (P_EX_SET_DEV_TO_DEFAULT_SETUP)GetProcAddress(hLibLL_USB, "EX_SetDevToDefaultSetup");
	if(!EX_SetDevToDefaultSetup) return FALSE;
	EX_SetScanType =  (P_DLL_EX_SET_SCAN_TYPE)GetProcAddress(hLibLL_USB, "EX_SetScanType");
	if(!EX_SetScanType) return FALSE;
	EX_SetMultiChanScanChans =  (P_DLL_EX_SET_MULTI_CHAN_SCAN_CHANS)GetProcAddress(hLibLL_USB, "EX_SetMultiChanScanChans");
	if(!EX_SetMultiChanScanChans) return FALSE;
	EX_SetMultiChanScanChans_TO_LOG =  (P_DLL_EX_SET_MULTI_CHAN_SCAN_LOG_CHANS)GetProcAddress(hLibLL_USB, "EX_SetMultiChanScanChans_TO_LOG");
	if(!EX_SetMultiChanScanChans_TO_LOG) return FALSE;
	EX_Run = (P_DLL_EX_RUN)GetProcAddress(hLibLL_USB, "EX_Run");
	if(!EX_Run) return FALSE;
	EX_Stop = (P_DLL_EX_STOP)GetProcAddress(hLibLL_USB, "EX_Stop");
	if(!EX_Stop) return FALSE;
	EX_StopComplete = (P_DLL_EX_STOP_COMPLETE)GetProcAddress(hLibLL_USB, "EX_StopComplete");
	if(!EX_StopComplete) return FALSE;

    return TRUE;
}


int __cdecl main()
{
	USHORT usDevID = 0; 
	BOOLEAN fRetVal = FALSE; BOOLEAN fRunning = FALSE; BOOLEAN fRedraw = FALSE;

	if(!LoadLibraries()){ printf("Failed to load libraries"); getch(); return 0;}
	printf("Success loading libraries\n");

	if(!InitLibFuncs())
	{ printf("Failed to find required functions"); getch(); return 0;}

	printf("Success finding required functions\nConnecting -  please wait. . .");
	fRetVal = EX_Connect(&usDevID);
	if(!(fRetVal | usDevID))
	{ printf("Failed  EX_Connect()"); getch(); return 0; }

	char cUserInputVal = NULL; char szOutVal[32], szTempBuff[32]; int iKeyChar = 0;  
	BYTE bLogChans;
	while(true)
	{
		setMainScreen();
		fRedraw = FALSE;

		while((cUserInputVal != 'Q') && (cUserInputVal != 'q') && (cUserInputVal != 27) && (!fRedraw))
		{
			sprintf(szOutVal, ""); 
			cUserInputVal = (char)getch();
			switch(cUserInputVal)
			{
				case 'Q': case 'q': case 27:
					printf("\nDisconnecting and exiting, please wait ....\n"); break;
				case 'R': case 'r':
					fRedraw = TRUE; system("cls"); break;
				case 'S': case 's':
					if(!fRunning)
					{
						if((!EX_SetScanType (usDevID, MULTI_CHAN_DIGIN_SCAN)) 
							|| (!EX_SetMultiChanScanChans (usDevID, 4)) 
							|| (!EX_Run(usDevID))
							) 
						{ printf("\nfailed to start scan run\n"); }

						else
						{ printf("\nScan running. Data being logged to disk file\n\tPress 'E' to end run\n"); fRunning = TRUE; }
					}
					else printf("Already running - Press 'E' to stop\n"); break;
				case 'E': case 'e':
					if(fRunning)
					{
						if(!EX_Stop(usDevID)) printf("\nfailed to stop scan run\n"); 
						else
						{ EX_StopComplete(usDevID); printf("\nScan Stopped.\n"); fRunning = FALSE; }
					}
					else printf("Already Stopped - Press 'S' to start scan run\n"); break;
				case 'M': case 'm':
					sprintf(szOutVal, ""); printf("\nenter channel log mask: ");
					while(TRUE)
					{
						// take care of backspaces and non-numerics
						if(((iKeyChar == 8) || (iKeyChar < 48) || (iKeyChar > 57)) && (strlen(szOutVal) > 0)) 
						{
							setMainScreen(); if(iKeyChar == 8) szOutVal[strlen(szOutVal)-1] = 0; 
							printf("\nenter channel log mask: %s", szOutVal);
							continue;
						}
						iKeyChar = getche(); if(iKeyChar == 13) break;
						sprintf(szTempBuff, "%u", ((BYTE)iKeyChar) - '0');
						strcat(szOutVal, szTempBuff); if(strlen(szOutVal) == 3) break;
					}
					
					if(((UINT)(atoi(szOutVal))) > 255)
					{ printf("\nvalue entered greater than 255. New value: 255 (all channel logging)"); sprintf(szOutVal, "255"); }
					bLogChans = (BYTE)(atoi(szOutVal));
					if(!EX_SetMultiChanScanChans_TO_LOG (usDevID, bLogChans)) printf("\nfailed to set data log channels\n"); 
					else printf("\ndata log mask  %d  sent\n", (BYTE)(atoi(szOutVal)));
					sprintf(szOutVal, ""); break;
				case 'I': case 'i':
					if(fRunning)
					{
						printf("can't do while running\n");
						break;
					}
					if(!EX_SetDevToIniSetup(usDevID))
					{
						printf("Failed loading configuration file. Not changing config settings\n"); 
						break;
					}
					printf("Configuration set to .INI parameters for dev: %u\n", usDevID); break;
				case 'D': case 'd':
					if(fRunning)
						break;
					if(!EX_SetDevToDefaultSetup(usDevID))
					{
						printf("Failed setting default configuration. Not changing config settings\n"); 
						break;
					}
					printf("Configuration set to DEFAULT parameters\n"); break;
			}
		}
		if(!fRedraw) break;
	}

	return 1;
}
void setMainScreen(void)
{
	system("cls");
	printf("\nINITIALIZED\n"
		"About the data-log channel mask usage:\n"
		" The option requires a bit-mask representing the channels to log.\n"
		" For example 80 (binary 10000000) indicates logging of only channel 7,\n"
		"   255 (binary 11111111) indicates logging of all channels, \n"
		"   85 (binary 1010101) indicates logging channels 0,2,4, and 6.\n\n"
		"Press one of the following keys:\n"
		"'Q' quit\n"
		"'R' redraw screen\n"
		"'M' set data-log channels\n"
		"'S' start scanning\n"
		"'E' end scanning\n"
		"'D' default config setting\n"
		"'I' INI config setting\n"
		);
}



// ##################################
// This file example demonstrates setting the configuration between that which is read from the M30x_SP.INI file
//   and the default values stored within the DLL. Between settings, a scan should be run and then the log file
//   reviewed to see the variation in the timing of the data collection.
// For testing purposes, set your M30x_SP.INI up according to what is shown below, replacing devID "[1105]" with
//   the device ID that is for your Model-30x:

//  [1105]
//  tScan=1
//  Rate=1000.00
//  LogScans=1
//  normalChan=0
//  multiChanScanNumChans=1

// All of the entries here are the same as those that used within the DLL as default values with the EXCEPTION OF THE RATE
//   used by the DLL is 100Hz while the rate shown here in the .INI file is 1000Hz. Be sure to make the default rate value 
//   any changes to the .INI file prior to starting the application. Any changes made once the DLL has initially read from 
//   the .INI file will be ignored due to the way that the WinAPI handles reading of a .ini file.

// When you first connect, the DLL will look for the M30x_SP.INI file and then look within the file for the device ID
//   that it has connected to. If it finds the device ID within that file, then it will load the settings from it. If
//   it does not find the file, or finds the file but not the device ID within the file, it will load it's default settings.
//   The default settings used by the DLL are the same as the values shown above with the exception of the rate being 100Hz.

// To see the functionality, connect to the device and then run a scan and observe the timings in the log file. With the 
//   settings above, the first log file should read (if using a Model-301 that uses chan 0,1,6,7) 
 

/*
Time / s 	ch-0      dig	ch-1      dig	ch-6      dig	ch-7      dig
0000000.00	 3.242552   1 	 1.588726   1 	 4.999940   1 	-0.000013   1 
0000000.02	 3.643209   1 	 2.487032   1 	 4.999928   1 	 0.000014   1 
0000000.04	 3.864536   1 	 3.007621   1 	 4.999940   1 	 0.000017   1 
0000000.06	 3.980724   1 	 3.279922   1 	 4.999964   1 	 0.000026   1 
0000000.08	 4.024772   1 	 3.377890   1 	 4.999968   1 	-0.000003   1 
0000000.10	 3.990931   1 	 3.468032   1 	 4.999950   1 	 0.000007   1 
*/

// and for a Model-302 which uses chans 0,1,2,3,4,5,6,7 :

/*
Time / s 	ch-0      dig	ch-1      dig	ch-2      dig	ch-3      dig
0000000.00	-0.000043   0 	 0.024607   0 	-0.024875   0 	-0.326875   0 
0000000.02	-0.000053   0 	 0.024602   0 	-0.024827   0 	-0.178235   0 
0000000.04	-0.000072   0 	 0.024650   0 	-0.024880   0 	-0.039442   0 
0000000.06	-0.000062   0 	 0.024641   0 	-0.024911   0 	 0.056838   0 
0000000.08	-0.000038   0 	 0.024607   0 	-0.024944   0 	-0.090922   0 
0000000.10	-0.000034   0 	 0.024629   0 	-0.024874   0 	-0.163991   0 
*/

// After setting to use the default configuration, by pressing the "D" key as per the application's menu and then
//   waiting for it to return, the output timing in the second log file after starting a new scan should be (for 
//   the Model-301)
/*
Time / s 	ch-0      dig	ch-1      dig	ch-6      dig	ch-7      dig
0000000.00	 3.499295   1 	 2.946880   1 	 4.999999   1 	-0.000008   1 
0000000.20	 3.645902   1 	 3.083324   1 	 4.999999   1 	-0.000003   1 
0000000.40	 3.772249   1 	 3.217191   1 	 4.999999   1 	-0.000003   1 
0000000.60	 3.817709   1 	 3.330855   1 	 4.999999   1 	-0.000005   1 
0000000.80	 3.894672   1 	 3.495595   1 	 4.999999   1 	-0.000003   1 
0000001.00	 3.937924   1 	 3.586003   1 	 4.999999   1 	-0.000005   1 
*/

// Note that the change in the rate from 1000 (from .ini file) to 100 (from DLL default) has caused
//   the decimal place in the timing of the data that is read to shift slowed by a factor of 10. You
//   may also notice that there is a higher resolution obtained at the slower rate where channel 6
//   has a lot more variation in the values that are read at 1000Hz. than at 100Hz.
// ##################################





























